LeetCode300. Longest Increasing Subsequence

来源:互联网 发布:单片机控制24v继电器 编辑:程序博客网 时间:2024/05/22 01:31

LeetCode300. Longest Increasing Subsequence

题目:

Given an unsorted array of integers, find the length of longest increasing subsequence.

For example,
Given [10, 9, 2, 5, 3, 7, 101, 18],
The longest increasing subsequence is [2, 3, 7, 101], therefore the length is 4. Note that there may be more than one LIS combination, it is only necessary for you to return the length.

Your algorithm should run in O(n2) complexity.

Follow up: Could you improve it to O(n log n) time complexity?

题意分析:一般是这种类型的关于长度的题目,很容易就想到了动态分析去。于是本题也是往动态分析去看的。

vector<int> dp(nums.size(), 1);int res = 0;for (int i = 0; i < nums.size(); ++i) {for (int j = 0; j < i; ++j) {if (nums[i] > nums[j]) {dp[i] = max(dp[i], dp[j] + 1);}}res = max(res, dp[i]);}

以下是代码部分:

class Solution {public:    int lengthOfLIS(vector<int>& nums) {        vector<int> dp(nums.size(), 1);int res = 0;for (int i = 0; i < nums.size(); ++i) {for (int j = 0; j < i; ++j) {if (nums[i] > nums[j]) {dp[i] = max(dp[i], dp[j] + 1);}}res = max(res, dp[i]);}return res;    }};


原创粉丝点击